unit OPCGroupDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, dOPC;

type
  TEditGroupDlg = class(TForm)
    Label3: TLabel;
    eGroupName: TEdit;
    eUpdateRate: TEdit;
    Label4: TLabel;
    eDeadBand: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    cActive: TCheckBox;
    bOk: TButton;
    BCancel: TButton;
    procedure FormShow(Sender: TObject);
    procedure bOkClick(Sender: TObject);
  private
    GroupParams : tGroupStateRec;
  public
  end;

function OPCEditGroupDialog(var GroupRec : tGroupStateRec): boolean;

implementation

{$R *.DFM}

function OPCEditGroupDialog(var GroupRec : tGroupStateRec): boolean;
var
  D : TEditGroupDlg;
begin
 result := false;
 Application.CreateForm(TEditGroupDlg,D);
 D.GroupParams := GroupRec;
 if (D.ShowModal() = idOk) then
 begin
   GroupRec := D.GroupParams;
   result := true;
 end;
 D.free();
end;



procedure TEditGroupDlg.FormShow(Sender: TObject);
begin
  eUpdaterate.Text := IntToStr(GroupParams.UpdateRate);
  eGroupName.Text  := GroupParams.Name;
  eDeadBand.Text   := format('%.2f',[GroupParams.DeadBand]);
  cActive.Checked  := GroupParams.IsActive;
end;

procedure TEditGroupDlg.bOkClick(Sender: TObject);
begin
  if trim(eGroupName.Text) <> '' then
  begin
    GroupParams.UpdateRate :=  StrToInt(eUpdaterate.Text);
    GroupParams.Name       :=  eGroupName.Text;
    GroupParams.DeadBand   :=  StrToFloat(eDeadBand.Text);
    GroupParams.IsActive   :=  cActive.Checked;
    close;
    ModalResult := mrOk;
  end
  else
  begin
    beep;
    eGroupName.SetFocus;
  end;
end;

end.
